#! /usr/bin/python

from pyx import *

c = canvas.canvas()

def avg(l):
    return sum(l) / len(l)

first_start = None
builds = []
for line in open("etch-times", "r").readlines():
    pieces = line.split()
    d = {}
    for i in range(0, 10, 2):
        word = pieces[i]
        if word in ("build", "numtests"):
            number = int(pieces[i+1])
        else:
            number = float(pieces[i+1])
        d[word] = number
    assert set(d.keys()) == set(["build", "start", "buildtime", "numtests",
                                 "testtime"]), d
    if first_start is None:
        first_start = d["start"]
    d["relstart"] = d["start"] - first_start
    #print d["build"], d["numtests"], d["testtime"]
    for k in ("buildtime", "testtime"):
        smooth = 1
        if len(builds) > smooth:
            d["smoothed_" + k] = avg([b[k] for b in builds[-smooth:]])
        else:
            d["smoothed_" + k] = d[k]
    builds.append(d)

builds.sort(lambda a,b: cmp(a["build"], b["build"]))

g1 = c.insert(graph.graphxy(width=16, # 16cm
                            #x=graph.axis.linear(texter=date),
                            ))
data1 = graph.data.list([ (d["relstart"], d["numtests"]) for d in builds ],
                        x=1, y=2)
g1.plot(data1, [graph.style.line()])
g2 = c.insert(graph.graphxy(width=16, ypos=g1.height+0.5,
                            x=graph.axis.linkedaxis(g1.axes["x"])))
data2 = graph.data.list([ (d["relstart"], d["smoothed_testtime"]) for d in builds ],
                        x=1, y=2)
g2.plot(data2, [graph.style.line()])

c.writePDFfile("graph.pdf")
print "done"
